function ConditionalController(){
	var self = this; self.name = "ConditionalController"; // MANDATORY

    this.xml_parser = new DOMParser();

		this.synchronizer = false;
    this.data = false;
    this.types = [];
    this.triggers = [];
    this.operators = [];
		
		this.acummulated_triggers_timer =0;

    this.unload = function(){
        self.types = null;
        self.triggers = null;
        self.data = null;
    };

    this.update = function(ConditionsElement){
        if(typeof(ConditionsElement) !== "undefined"){
            self.data = null;
            self.data = ConditionsElement;
						var new_types = self.data.getTypes(true);
						for(var i=0;i<new_types.length;i++){
							var index = self.types.map(function(e){return e.filename;}).indexOf(new_types[i].filename);
							if(index >= 0){
								new_types[i].last_value = self.types[i].last_value;
								new_types[i].last_tstamp = parseInt(self.types[i].last_tstamp);
							}
						}
            self.types = null;
            self.types = new_types;
						new_types = null;
            self.getConditionsFileValue();
            self.triggers = null;
            self.triggers = self.data.getTriggers(true);
        }
				if(self.synchronizer){
					$(self.synchronizer).one("on"+self.name+"SyncRecieve",self.onSyncRecieve);
				}
    };

		this.onSyncRecieve = function(event,action){
			if(self.synchronizer.using_mode == self.synchronizer.MODE_MASTER){
				if(action.do == "slave_condition"){
					self.log("Master Recieved condition from Client !!");
					action.condition.broadcast = true;
					self.onNewConditionValue(action.condition,false);
        }
			}
    };

    this.onNewConditionValue = function(condition,write_file,sync_exclude){
				if(typeof(sync_exclude) === "undefined"){sync_exclude = false;}
        if(typeof(write_file) === "undefined"){write_file = false;}
				
				var execute_condition = true;
				if(self.synchronizer){
					if(self.synchronizer.using_mode != self.synchronizer.MODE_MASTER){
						execute_condition = false;
						if(typeof(condition.broadcast) !== "undefined"){
							if(condition.broadcast){
								execute_condition = true;
							}else{
								self.log("Slave Send condition !!");
								self.synchronizer.broadcast({sender:self.name,action:{do:"slave_condition",condition:condition,write:false,time:self.getDate().getTime(), player_id:self.core_id}});
							}
						}
					}else{
						self.log("Master Send Broadcast condition !!");
						condition.broadcast = true;
						self.synchronizer.broadcast({sender:self.name,action:{do:"condition",condition:condition,write:false,time:self.getDate().getTime(), player_id:self.core_id}});
					}
				}				
        
				if(execute_condition){
						// TODO: Check interval.
						var is_new = false;
		        var index = self.types.map(function(e){return e.filename;}).indexOf(condition.filename);
		        if(index >= 0){
								
		            self.types[index].last_value = condition.value;
								if(typeof(condition.tstamp) !== "undefined"){
									if(condition.tstamp != self.types[index].last_tstamp){
										self.types[index].last_tstamp = condition.tstamp;
										is_new = true;
									}
			          }
								if(self.triggers.length > 0 && is_new){
		                self.checkTriggers(condition);
		            }
		        }
		        if(write_file && is_new){
		            self.writeConditionFile(condition);
		        }
				}
				if(self.content_api){
					self.content_api.broadcastApiContentEvent(self.content_api.API_CONDITION,condition);
				}
    };

    this.writeConditionFile = function(condition){
        try{
            if(typeof(condition) !== "undefined"){
                var xml = '<?xml version="1.0" encoding="UTF-8"?>';
                xml += '<condition id="'+condition.id+'" ';
                xml += 'tstamp="'+condition.tstamp+'" ';
                xml += 'version="'+condition.version+'" ';
                xml += 'status="'+condition.status+'">';
                xml += '<value>'+condition.value+'</value>';
                xml += '<info> --- </info></condition>';
                self.OS.writeFile(self.ROUTES['CONDITION'].path+condition.filename,xml);
            }
        }catch(e){
             self.notifyError(self.ERROR['CONDITIONAL_CONTROLLER']+2,self.name+": Function writeConditionFile() error : can not write condition file ... ");
        }
    };

    this.getConditionsFileValue = function(){
        for(var i=0;i<self.types.length;i++){
            self.OS.readFile(self.ROUTES['CONDITION'].path+self.types[i].filename,function(data,file_ref,index){
                try{
                    var filename = file_ref.substring(file_ref.lastIndexOf('/')+1,file_ref.length);
										if(data !== ""){
											var xmlDoc = self.xml_parser.parseFromString(data,"text/xml");
	                    self.types[index].last_value = xmlDoc.getElementsByTagName("value")[0].childNodes[0].nodeValue;
											self.types[index].last_tstamp= parseInt(xmlDoc.getElementsByTagName("condition")[0].getAttribute('tstamp'));
										}
                }catch(e){
                    self.notifyError(self.ERROR['CONDITIONAL_CONTROLLER']+1,self.name+": Function onConditionFileChange() error : can not read condition file "+filename+" : "+e.toString());
                }
            },i);
        }
    };

    this.checkTriggers = function(condition){
        var affects = self.data.getInvolved(condition.id);
        var satisfies = -1;
        for(var i=0;i<affects.length;i++){
            if(affects[i]){
                satisfies = self.checkConditions(self.triggers[affects[i]].conditions);
                if(satisfies >= 0){
                    // TODO: Interval & Cancelable
										clearTimeout(self.acummulated_triggers_timer);
										var interruption = self.triggers[affects[i]].interruption;
										var action = self.triggers[affects[i]].conditions[satisfies].action;
										var action_value = self.triggers[affects[i]].conditions[satisfies].value;
										self.acummulated_triggers_timer = setTimeout((function(interruption,action,action_value){
											$(self).trigger("ConditionTrigger",[interruption,action,action_value]);
										}).bind(null,interruption,action,action_value),250);
                    break;
                }
            }
        }
    };
		
    this.checkConditions = function(conditions){
        var condition_index = -1;
        var satifies = false;
        for(var i=0;i<conditions.length;i++){
            satifies = self.checkClauses(conditions[i].clauses);
            if(satifies){
                condition_index = i;
                break;
            }
        }
        return condition_index;
    };

    this.checkClauses = function(clauses){
        var last_value = 0;
				var last_tstamp = 0;
        var operation = false;
        var satifies = true;
        for(var i=0;i<clauses.length;i++){
            var index = self.types.map(function(e){return e.id;}).indexOf(clauses[i].id);
            if(index >= 0){
                last_value = self.types[index].last_value;
								last_tstamp = self.types[index].last_tstamp;
            }
            operation = self.operators[clauses[i].operator](clauses[i].satisfies,last_value);
            if(!operation){
                satifies = false;
                break;
            }
        }
        return satifies;
    };

    this.createConditionsObject = function(Element){
        var conditions = false;
        if(Element.length > 0){
						if(self.data){
							conditions = self.data.getConditionsFromElement(Element);
						}
        }
        return conditions;
    };

    this.operators["eq"] = function(satifies,value){
        if(value == satifies) return true;
        else return false;
    };

    this.operators["ne"] = function(satifies,value){
        if(value != satifies) return true;
        else return false;
    };

    this.operators["lt"] = function(satifies,value){
        if(!isNaN(satifies) && !isNaN(value)){
            if(parseInt(value) < parseInt(satifies)) return true;
            else return false;
        }else{
            return false;
        }
    };

    this.operators["le"] = function(satifies,value){
        if(!isNaN(satifies) && !isNaN(value)){
            if(parseInt(value) <= parseInt(satifies)) return true;
            else return false;
        }else{
            return false;
        }
    };

    this.operators["gt"] = function(satifies,value){
        if(!isNaN(satifies) && !isNaN(value)){
            if(parseInt(value) > parseInt(satifies)) return true;
            else return false;
        }else{
            return false;
        }
    };

    this.operators["ge"] = function(satifies,value){
        if(!isNaN(satifies) && !isNaN(value)){
            if(parseInt(value) >= parseInt(satifies)) return true;
            else return false;
        }else{
            return false;
        }
    };

    this.createConditionsStat = function(condition_types){
        var stats_info_string = "";
        var is_shot = 0;
        var count_stat = true;
        var index = -1;
        for(var i=0;i<condition_types.length;i++){
            index = self.types.map(function(e){return e.id;}).indexOf(condition_types[i]);
            if(index >= 0){
                if(!self.types[index].count_all){
                    count_stat = false;
                    // TODO : check if condition is been thrown by active content_id as condition.  ¿?
                    /* CODE FROM PLAYER ADOBE AIR
                    if(this._lastSelectedContentByCondition == lContentId && this._lastSelectedConditionType == lConditions['id'][lIndex]){
							this._lastSelectedContentByCondition = "";
							this._lastSelectedConditionType = -1;
							countStat = true;
							isShot = 1;
						}
                    */
                    is_shot = 0;
                }
                if(self.types[index].last_value == ""){
                    count_stat = false;
                }
                if(count_stat){
                    if(stats_info_string != ""){
                        stats_info_string += ",";
                    }
                    if(isNaN(self.types[index].last_value)){
                        stats_info_string += '{"id":'+self.types[index].id+',"value":"'+self.types[index].last_value+'","shoot":'+is_shot+'}';
                    }else{
                        stats_info_string += '{"id":'+self.types[index].id+',"value":'+self.types[index].last_value+',"shoot":'+is_shot+'}';

                    }
                }
            }
        }
        return stats_info_string;
    };
}
ConditionalController.prototype = new SystemController();
