var player = false;
var transfer = false;
var inactivityTimer = 0;
var manager = false;

document.addEventListener('deviceready', function(){
    window.plugins.insomnia.keepAwake();
    var appDir = "";
    var systemInfo = navigator.userAgent || navigator.vendor || window.opera;
    systemInfo = systemInfo.toLowerCase();
    var uuid = device.uuid;
    console.log("UUID is : "+uuid);
    if(systemInfo.match(/iphone/i)
          || systemInfo.match(/ipad/i)
          || systemInfo.match(/ipod/i)){
            appDir = cordova.file.documentsDirectory+"ADmira/";
    }else if(systemInfo.match(/android/i)){
        appDir = cordova.file.externalRootDirectory+"ADmira/";
    }
    $.get(appDir+'app/cordova.ver', function(data, status) {  
       console.log("File request status: "+status); 
    }).done(function() {
        console.log("System is updatable.");
        document.location = appDir+"app/cordova.html";
        console.log( "second success" );
    }).fail(function() {
        console.log("has no external installation");
        $(document).ready(function(){  
            try{
              if(!player){
                  player = new PlayerController();
                  $(player).on("PlayerDataLoaded",onPlayerDataLoaded);
                  player.init();
              }        
            }catch(e){
              console.log("Unable to start player");
              try{
                if(player.platform == "ANDROID"){
                    cordova.plugins.backgroundMode.enable();
                }
                if(!transfer){
                    transfer = new TransferService();
                    transfer.init(player.version);
                    transfer.setLogger(player.logger);
                }
                var archive = [];
                try{
                  archive = player.dataManager.getArchiveFiles();
                }catch(e){
                  console.log("No Archive !");
                }
                transfer.update(player.timestamp,archive);
                transfer.activateLogger(player.debug);
              }catch(e){
                console.log("Unable to start transfer");
              }
              try{
                schedule = player.config.getScheduleConfig();
              }catch(e){
                console.log("No Schedule !");
              }
              try{
                if(!manager){
                    manager = new ManagerService();
                    manager.init();
                    manager.setLogger(player.logger);
                }
                manager.update(schedule);
                manager.activateLogger(player.debug);
              }catch(e){
                console.log("Unable to start manager");
              }
            }
        });
    });
}, false);  

function onPlayerDataLoaded(){  
  try{
    if(player.platform == "ANDROID"){
        cordova.plugins.backgroundMode.enable();
    }
    if(!transfer){
        transfer = new TransferService();
        transfer.init(player.version);
        transfer.setLogger(player.logger);
    }
    var archive = [];
    try{
      archive = player.dataManager.getArchiveFiles();
    }catch(e){
      console.log("No Archive !");
    }
    transfer.update(player.timestamp,archive);
    transfer.activateLogger(player.debug);
  }catch(e){
    console.log("Unable to start transfer");
  }
  try{
    schedule = player.config.getScheduleConfig();
  }catch(e){
    console.log("No Schedule !");
  }
  try{
    if(!manager){
        manager = new ManagerService();
        manager.init();
        manager.setLogger(player.logger);
    }
    manager.update(schedule);
    manager.activateLogger(player.debug);
  }catch(e){
    console.log("Unable to start manager");
  }
}
