function BasicService(){
    if(arguments.callee._singletonInstance){
	    return arguments.callee._singletonInstance;
	}
	arguments.callee._singletonInstance = this;

	var self = this; self.name = "BasicService"; // MANDATORY

    this.internet_connected = false;
    this.api_connector = new ApiConnector();
    //this.SocketConnector = null;

    // BASIC PARAMS
	this.debug = true;
    this.logger = null;
    this.debug_filter = ""; // Use Class Name to filter

    this.OS = false;
    this.platform = "WEB";
    this.version = "s2.5.3";
    this.verbose = false;
    this.trim_path = true;
    this.debug_log = "";
    this.loglines = 0;
    this.log_max_lines = 100;
    this.error_identifier_base = 30000;
    this.error_identifiers = [];
    this.intervalManagement = 20000;
    this.bundle = "0";
    this.xml_timestamp = 0;
    this.pass = 0;
    this.started = false;

    this.systemInfo = navigator.userAgent || navigator.vendor || window.opera;
    this.systemInfo = this.systemInfo.toLowerCase();

    // API
    this.defaultDomain = "www.admira.mobi";
    this.api_url = "apilb.admira.com";
    this.api_server_url = "apilb.admira.com";
    this.api_ver = "3.0";
    this.core_id = "0";

    // IOT
    this.iot_url = "iotlb.admira.com";
    this.iot_ver = "1.0";

    // FILES & FOLDERS PATHS
    this.ROUTES = [];
    this.ROUTES["BASE"] = {"path": "./", "exists":true, "isFolder":true};
    this.ROUTES["MAIN_HTML"] = {"path": "admira.html", "exists":true, "isFolder":false};
    this.ROUTES["MAIN_JS"] = {"path": "admira.js", "exists":true, "isFolder":false};
    this.ROUTES["CORE"] = {"path": "core.xml", "exists":false, "isFolder":false};
    this.ROUTES["TIMESTAMP"] = {"path": "week.tstamp", "exists":false, "isFolder":false};
    this.ROUTES["MANIFEST"] = {"path": "", "exists":false, "isFolder":false};
    this.ROUTES["VER"] = {"path": "admira.ver", "exists":false, "isFolder":false};
    this.ROUTES["LICENSE"] = {"path": "admira.lic", "exists":false, "isFolder":false};
    this.ROUTES["CONFIG"] = {"path": "player.xml", "exists":false, "isFolder":false};
    this.ROUTES["DATA"] = {"path": "", "exists":false, "isFolder":false};
    this.ROUTES["CONTENT"] = {"path": "content/", "exists":false, "isFolder":true};
    this.ROUTES["XML"] = {"path": "xmls/", "exists":false, "isFolder":true};
    this.ROUTES["STAT"] = {"path": "stats/", "exists":false, "isFolder":true};
    this.ROUTES["ERROR"] = {"path": "errors/", "exists":false, "isFolder":true};
    this.ROUTES["LOG"] = {"path": "log/", "exists":false, "isFolder":true};
    this.ROUTES["TMP"] = {"path": "temp/", "exists":false, "isFolder":true};
    this.ROUTES["CONDITION"] = {"path": "conditions/", "exists":false, "isFolder":true};
    this.ROUTES["MODULE"] = {"path": "modules/", "exists":false, "isFolder":true};
    this.ROUTES["ANALYTIC"] = {"path": "analytics/", "exists":false, "isFolder":true};
    this.ROUTES["STYLE"] = {"path": "app/style/", "exists":false, "isFolder":true};
    this.ROUTES["REBOOT"] = {"path": "reboot.txt", "exists":false, "isFolder":false};

    // ERRORS LIST
    this.ERROR = [];
    this.ERROR['EXCEPTION'] = 0;
    this.ERROR['BASIC_SERVICE'] = 100;
    this.ERROR['FILE_MANAGER_SERVICE'] = 200;
    this.ERROR['MANAGER_SERVICE'] = 300;
    this.ERROR['REGISTER_SERVICE'] = 400;
    this.ERROR['STATISTIC_SERVICE'] = 500;
    this.ERROR['TRANSFER_SERVICE'] = 600;
    this.ERROR['CONDITIONAL_SERVICE'] = 700;
    this.ERROR['SCREEN_SERVICE'] = 800;

    // TIME
    this.server_time_activated = false;
    this.server_time_timestamp = 0;
    this.server_time_local_offset = 0;
    this.server_time_timezone_offset = 0;
    this.server_time_future_change_timestamp = 0;
    this.server_time_future_change_offset = 0;

    // NETWORK
    this.local_ip = "0.0.0.0";
    this.local_netmask = "0.0.0.0";
    this.local_gateway = "0.0.0.0";

    this.setTrimPath = function(activate){
        self.trim_path = activate;
    };

	this.activateLogger = function(enabled){
		if(typeof enabled == "boolean"){
			self.debug = enabled;
		}
		if(self.logger !== null && self.logger !== undefined){
			if(self.debug){
				self.logger.show();
			}else{
				self.logger.hide();
			}
		}
        if(enabled === true){
            if(self.OS !== false){self.OS.activateControl();}
        }
        else{
            if(self.OS !== false){self.OS.deactivateControl();}
        }
	};

	this.setLogger = function(element){
		self.logger = null;
		self.logger = element;
	};

	this.log = function(text){
    try{
      if(self.debug){
        if(self.OS !== false){self.OS.sendControlLog("BasicService", this.name, text);}
          var add_line = true;
          if(self.debug_filter != ""){
              if(this.name != self.debug_filter){
                  add_line = false;
              }
          }
          if(add_line){
                var datetime = this.getFullDateFormatted();//moment().format('HH:mm:ss.SSS - DD/MM/YYYY');
              if(self.loglines > self.log_max_lines){
                  self.loglines = 0;
              }
              var type_of_datetime = "L"; // L for local - S for Server
              if(self.server_time_activated){type_of_datetime = "S";}
              var text_log = type_of_datetime+" ["+datetime+"] : "+this.name+" : "+text;
              if(self.logger !== null && self.logger !== undefined){
                  if(self.loglines == 0){
                      self.clearLog();
                  }
                  self.logger.prepend("<br> "+text_log);
              }else{
                  console.log(text_log);
              }
              self.debug_log = text_log + self.debug_log;
              self.loglines++;
              datetime = null;
              type_of_datetime = null;
              text_log = null;
          }

      }
    }catch(e){
      console.log("Unexpected Exception occurred on BasicService.js");
      console.log(e);
    }
	};

	this.clearLog = function(){
		self.logger.html("");
        self.debug_log = "";
	};

    this.isValid = function(something){
		var valid = true;
		if(something === null || typeof(something) === "undefined"){
			valid = false;
		}
		return valid;
	};

	this.usedMemory = function(){
		var memory = parseInt(window.performance.memory.usedJSHeapSize)/1024;
		this.log("Used Memory : "+memory+"Kb");
	};

	this.execute = function(callback){
		var executes = false;
		var value = null;
		try{
			value = callback();
			executes = true;
		}catch(ex){
			if(self.verbose){
                self.log(">Exception : [ "+ex.name+" with message : "+ex.message+" ]");
				self.log(">Caller : [ "+self.execute.caller+" ]");
                self.notifyError("ex: "+ex.name+" file: "+self.execute.caller+" message: "+ex.message);
			}
		}

		if(executes){
			if(typeof(value) != "undefined"){
				return value;
			}else{
				return false;
			}
		}else{
			return false;
		}
        /// TODO : ADD FAIL CALLBACK PROCEDURE
	};

    this.getFullDateFormatted = function(utc){
        if(typeof(utc) === "undefined"){ utc = self.server_time_activated; }
        var d = self.getDate();
        if(utc){
            var month = '' + (d.getUTCMonth() + 1),
            day = '' + d.getUTCDate(),
            year = d.getUTCFullYear(),
            hours = d.getUTCHours(),
            minutes = d.getUTCMinutes(),
            seconds = d.getUTCSeconds(),
            milliseconds = d.getUTCMilliseconds();
        }else{
            var month = '' + (d.getMonth() + 1),
            day = '' + d.getDate(),
            year = d.getFullYear(),
            hours = d.getHours(),
            minutes = d.getMinutes(),
            seconds = d.getSeconds(),
            milliseconds = d.getMilliseconds();
        }
        if (month.length < 2) month = '0' + month;
        if (day.length < 2) day = '0' + day;
        if (hours.length < 2) hours = '0' + hours;
        if (minutes.length < 2) minutes = '0' + minutes;

        return day+"/"+month+"/"+year+" "+hours+":"+minutes+":"+seconds+"."+milliseconds;
    };

    this.setServerTimeParams = function(localTime,serverTime,timezoneOffset,future_change_timestamp,future_change_offset){
        if(typeof(localTime) !== "undefined" && typeof(serverTime) !== "undefined"){
            self.server_time_local_offset = localTime - serverTime;
            self.server_time_timestamp = serverTime;
        }
        if(typeof(timezoneOffset) !== "undefined"){
            self.server_time_timezone_offset = timezoneOffset;
        }
        if(typeof(future_change_offset) !== "undefined"){
            self.server_time_future_change_offset = future_change_offset;
        }
        if(typeof(future_change_offset) !== "undefined"){
            self.server_time_future_change_offset = future_change_offset;
        }
        /*
        self.log("server_time_activated : "+self.server_time_activated);
        self.log("server_time_local_offset : "+self.server_time_activated);
        self.log("server_time_timezone_offset : "+self.server_time_timezone_offset);
        self.log("server_time_future_change_offset : "+self.server_time_future_change_offset);
        self.log("server_time_future_change_offset : "+self.server_time_future_change_offset);
        self.log("getdate = "+self.getDate());
        self.log("getdateFormated = "+self.getFullDateFormatted());
        */
        self.setServerTimeActivation(true);
    };


    this.setServerTimeActivation = function(activated){
        if(!activated){
            self.server_time_timestamp = 0;
            self.server_time_local_offset = 0;
            self.server_time_timezone_offset = 0;
            self.server_time_future_change_timestamp = 0;
            self.server_time_future_change_offset = 0;
        }
        self.server_time_activated = activated;
    };

    this.getDate = function(utc,timestamp){
        if(typeof(timestamp) === "undefined"){ timestamp = -1; }
        if(typeof(utc) === "undefined"){ utc = false; }
        var systemDate = new Date();
        if(self.server_time_activated){
            var timezone_offset = 0;
            if(!utc){
                timezone_offset = self.server_time_timezone_offset*-1;
            }
            if(timestamp >= 0){
                timestamp = (timestamp+timezone_offset);
            }else{
                var system_timestamp = systemDate.getTime();
                if(self.platform == "SOC"){
                     var time_api = document.getElementById('timePlugin');
                     time_api.Open('Time', '1.000', 'Time');
                     system_timestamp = parseInt(time_api.Execute('GetEpochTime'));
                     time_api.Close();
                     time_api = null;
                     system_timestamp = system_timestamp * 1000;
                }
                timestamp = (system_timestamp+(self.server_time_local_offset*-1)+(timezone_offset));
            }
            systemDate = new Date(timestamp);
        }else{
             if(self.platform == "SOC"){
                 var time_api = document.getElementById('timePlugin');
                 time_api.Open('Time', '1.000', 'Time');
                 timestamp = parseInt(time_api.Execute('GetEpochTime'));
                 time_api.Close();
                 timestamp = timestamp * 1000;
                 var d = new Date(timestamp);
                 var offset = d.getTimezoneOffset();
                 offset = offset * 60;
                 offset = offset * 1000;
                 timestamp += offset;
                 time_api = null;
            }
            if(timestamp > 0){
                systemDate = new Date(timestamp);
            }
        }
        return systemDate;
    };

    this.getDayOfWeek = function(){
        var dayOfTheWeek = self.getDate().getDay();
        if(dayOfTheWeek == 0) dayOfTheWeek = 7;
        return dayOfTheWeek;
    };

    this.setCoreId = function(id){
        self.core_id = id;
        self.OS.changeCore(id);
    };

    this.setAPIroutes = function(data){
        if(typeof(data) !== "undefined"){

            var parser=new DOMParser();
            var xmlDoc=parser.parseFromString(data,"text/xml");
            self.api_url = xmlDoc.getElementsByTagName("api_url")[0].childNodes[0].nodeValue;
            self.api_server_url = xmlDoc.getElementsByTagName("server")[0].getAttribute('url');
            var new_api_ver = ""+xmlDoc.getElementsByTagName("api_ver")[0].childNodes[0].nodeValue;
            if( new_api_ver !== "2.0"){
              self.api_ver = new_api_ver;
            }
            self.core_id = xmlDoc.getElementsByTagName("id")[0].childNodes[0].nodeValue;
            self.setCoreId(self.core_id);
        }
    };

    this.setPaths = function(data){
      if(typeof(data) !== "undefined"){
        var parser=new DOMParser();
        var xmlDoc=parser.parseFromString(data,"text/xml");
        self.ROUTES['DATA'].path = xmlDoc.getElementsByTagName("data")[0].getAttribute('file');
        self.ROUTES['CONTENT'].path = xmlDoc.getElementsByTagName("paths")[0].getAttribute('content');
        self.ROUTES['XML'].path = xmlDoc.getElementsByTagName("paths")[0].getAttribute('xmls');
        self.ROUTES['TMP'].path = xmlDoc.getElementsByTagName("paths")[0].getAttribute('temp');
        self.ROUTES['MODULE'].path = xmlDoc.getElementsByTagName("paths")[0].getAttribute('modules');
        self.ROUTES['STAT'].path = xmlDoc.getElementsByTagName("paths")[0].getAttribute('stadistics');
      }
    };

    this.setPlatform = function(force_platform){
        if(typeof(force_platform) !== "undefined"){
            self.platform = force_platform;
            self.log("Platform Forced: "+self.platform);
        }else{
            if(self.systemInfo.match(/iphone/i)
              || self.systemInfo.match(/ipad/i)
              || self.systemInfo.match(/ipod/i)){
                self.platform = "IOS";
            }else if(self.systemInfo.match(/android/i)){
                self.platform = "ANDROID";
            }else if(self.systemInfo.match(/msie/i)){
                self.platform = "WIN8";
            }else if(self.systemInfo.match(/web0s/i)){
                self.platform = "WEBOS";
            }else if(self.systemInfo.match(/tizen/i)){
                self.platform = "TIZEN";
            }else if(self.systemInfo.match(/smarttv/i)){
                self.platform = "SOC";
            }else if(self.systemInfo.match(/cros/i)){
                self.platform = "CHROMEOS";
            }else if(self.systemInfo.match(/macintosh/i)){
                self.platform = "MAC";
            }else if(self.systemInfo.match(/windows/i)){
                self.platform = "WIN";
            }else if(self.systemInfo.match(/brightsign/i)){
                self.platform = "BRIGHT";
            }else if(self.systemInfo.match(/linux/i)){
                self.platform = "LINUX";
            }
            self.log("Platform : "+self.platform+" Environment : "+self.systemInfo);
        }
        self.setOs();
    };

    this.setOs = function(){
        if(self.platform == "IOS"){
            self.ROUTES["STYLE"].path = "./style/";
            self.ROUTES["MAIN_HTML"].path = "index.html";
            self.ROUTES["MAIN_JS"].path = "none";
            self.ROUTES["MANIFEST"].path = "none";
            self.OS = new CordovaSystemController();
        }else if(self.platform == "ANDROID"){
            self.ROUTES["STYLE"].path = "./style/";
            self.ROUTES["MAIN_HTML"].path = "index.html";
            self.ROUTES["MAIN_JS"].path = "none";
            self.ROUTES["MANIFEST"].path = "none";
            self.OS = new CordovaSystemController();
        }else if(self.platform == "WIN8"){
            self.ROUTES["STYLE"].path = "./style/";
            self.ROUTES["MAIN_HTML"].path = "index.html";
            self.ROUTES["MAIN_JS"].path = "none";
            self.ROUTES["MANIFEST"].path = "none";
            self.OS = new CordovaSystemController();
        }else if(self.platform == "WEBOS"){
            self.ROUTES["MAIN_HTML"].path = "webos.html";
            self.ROUTES["STYLE"].path = "style/";
            self.ROUTES["MAIN_JS"].path = "none";
            self.ROUTES["MANIFEST"].path = "none";
            self.OS = new WebOsSystemController();
        }else if(self.platform == "TIZEN"){
            self.ROUTES["MAIN_HTML"].path = "tizen.html";
            self.ROUTES['STYLE'].path = "style/";
            self.ROUTES['STYLE'].exists = false;
            self.ROUTES["MAIN_JS"].path = "none";
            self.ROUTES["MANIFEST"].path = "none";
            self.OS = new TizenSystemController();
        }else if(self.platform == "SOC"){
            self.ROUTES["MAIN_HTML"].path = "index.html";
            self.ROUTES["MAIN_JS"].path = "none";
            self.ROUTES["MANIFEST"].path = "none";
            self.OS = new SoCSystemController();
        }else if(self.platform == "CHROMEOS"){
            self.ROUTES['STYLE'].path = "style/";
            self.ROUTES['STYLE'].exists = false;
            self.ROUTES["MAIN_HTML"].path = "chrome.html";
            self.ROUTES["MAIN_JS"].path = "chrome.js";
            self.ROUTES["MANIFEST"].path = "manifest.json";
            self.OS = new ChromeSystemController();
        }else if(self.platform == "MAC"){
            self.ROUTES["MAIN_HTML"].path = "admira.html";
            self.ROUTES["MAIN_JS"].path = "admira.js";
            self.ROUTES["MANIFEST"].path = "package.json";
            self.OS = new NwjsSystemController(self.platform);
        }else if(self.platform == "WIN"){
            self.ROUTES["MAIN_HTML"].path = "admira.html";
            self.ROUTES["MAIN_JS"].path = "admira.js";
            self.ROUTES["MANIFEST"].path = "package.json";
            self.OS = new NwjsSystemController(self.platform);
        }else if(self.platform == "LINUX"){
            self.ROUTES["MAIN_HTML"].path = "admira.html";
            self.ROUTES["MAIN_JS"].path = "admira.js";
            self.ROUTES["MANIFEST"].path = "package.json";
            self.OS = new NwjsSystemController(self.platform);
        }else if(self.platform == "WEB"){
            self.ROUTES["MAIN_HTML"].path = "web.html";
            self.ROUTES["MAIN_JS"].path = "none";
            self.ROUTES["MANIFEST"].path = "none";
            self.OS = new OperatingSystemController();
        }else if(self.platform == "ONLINE"){
            self.ROUTES["MAIN_HTML"].path = "online.html";
            self.ROUTES["MAIN_JS"].path = "none";
            self.ROUTES["MANIFEST"].path = "none";
            self.ROUTES["CONFIG"].path = "online_player.xml";
            var protocol = document.location.href;
            protocol = protocol.substring(0,protocol.indexOf(":"));
            self.api_connector.protocol = protocol+"://";
            self.OS = new OperatingSystemController();
        }else if(self.platform == "BRIGHT"){
	            self.ROUTES["MAIN_HTML"].path = "brightsign.html";
	            self.ROUTES["MAIN_JS"].path = "none";
	            self.ROUTES["MANIFEST"].path = "none";
							self.OS = new BrightSystemController();
	      }

    };

    this.saveStatusFile = function(data){
        if(self.OS){
            if(data){
                self.OS.writeFile(self.ROUTES["LOG"].path+data.player+"."+data.id+"."+data.name,JSON.stringify(data));
            }
        }
    };

    this.getStatusFile = function(data,callback,params){
        try{
           if(self.OS){
               self.OS.readFile(self.ROUTES["LOG"].path+data.player+"."+data.id+"."+data.name,function(value,file_ref,params){
                    var data_object = false;
                    if(value != ""){
                        try{
                            data_object = JSON.parse(value);
                        }catch(e){
                            if(typeof(callback) !== "undefined"){
                                callback(data_object,params);
                            }
                        }
                    }
                    if(typeof(callback) !== "undefined"){
                        callback(data_object,params);
                    }
                },params);
            }
        }
        catch(e){
            if(typeof(callback) !== "undefined"){
                callback(false);
            }
        }
    };

    this.notifyError = function(error_id,msg,opt_data){
        try{
            error_id = self.error_identifier_base + error_id;
            if(self.error_identifiers.indexOf(error_id) === -1 || error_id == self.error_identifier_base){
                if(self.OS != false){
                    self.error_identifiers.push(error_id);
                    var last_log = "";
                    if(self.debug_log.length < 10000){
                        last_log = btoa(self.debug_log);
                    }
                    var timestamp = parseInt(self.getDate().getTime()/1000);
                    var extra_data = "";
                    if(typeof(opt_data) != "undefined"){
                        extra_data = opt_data;
                    }
                    var error_json = '{ "senderID" : "'+self.core_id+'" , "tstamp": "'+timestamp+'" , "errorID" : "'+error_id+'" , "errorLog":"'+last_log+'", "extraData":"'+extra_data+'", "errorMessage" : { "message":"'+msg+'"}}';
                    self.log("ErrorNotifier "+error_id+": "+self.ROUTES["LOG"].path+self.core_id+"_"+timestamp+".err");
                    self.log("ErrorMsg : "+msg);
                    if(self.platform != "ONLINE"){
                      try{
                        self.OS.writeFile(self.ROUTES["LOG"].path+self.core_id+"_"+error_id+".err",error_json);
                      }catch(e){
                        // do nothing
                      }
                    }
                  }
            }else{
                self.log("ErrorNotifier "+error_id+" Already Notified");
            }
        }
        catch(e){
            self.log("ErrorNotifier "+error_id+" error: "+JSON.stringify(e));
        }
    };

    if(typeof(window) !== "undefined"){
        window.onerror = function(errorMsg, url, lineNumber){
            self.log("Window Error !!! on line : "+lineNumber+" "+url);
            self.log(">>>>>>>>>>>>> Message : "+errorMsg);
            self.notifyError(0,"line: "+lineNumber+" script: "+url+" message: "+errorMsg);
            return true;
        };
    }
}
//BasicService.prototype = new SystemController();
